#ifndef __dbq_h
#define __dbq_h
#include "filed.h"

void dbq(int filter, int id, char *query);
void dbq_rm(struct db *d);
struct db *dbq_get_slot(int i);
void dbq_handle(void);
struct db *dbq_get_tail(void);
int dbq_get_seq(void);
void dbq_process(void);

#define DBFLAG_PROCESSING 1
#define DBFLAG_DONE 2


/* positive filters are defined as being external-targetted functions */
/* negative filters are defined as being internal-targetted functions */

/* a good example of negative filters at work is -1, the load playlist filter */
/* when a query is run with -1, the select statement asks for the next entry 
   in the playlist, the result is inserted directly into the appropriate
   structures by the database event handler */

/* A word about multiple returns: Many queries return many lines, as you
 * are probebly aware. For queries writing to a connection, this is handled
 * by a simple rule that says no new queries can be loaded from the stack
 * when one is currently running. For system-based queries, return
 * ordering is enforced, so until a query finishes no other query can
 * use that channel
 *
 * the downside of all this is that it is QUITE possible to run out
 * of database channels. 
 *
 * One more note: it is unfortunately quite possible for the database thread
 * to die off leaving filed databaseless. We detect this condition
 * by setting a flag and checking to see that it gets unset 
 */
#endif
